package hirondelle.web4j.config;

import hirondelle.web4j.database.ConnectionSource;
import hirondelle.web4j.database.DAOException;

import java.sql.Connection;
import java.util.Collections;
import java.util.Map;
import java.util.Set;

/** 
* Implementation of {@link ConnectionSource}, required by WEB4J.
* 
* <P>This implementation returns empty and null items.
*/
public final class ConnectionSrc implements ConnectionSource  {

  /** This implementation is empty.  */
  public void init(Map<String, String> aConfig){
    //emtpy    
  }
  
  /** Returns an empty set, to indicate to web4j that no database is used in this app. */
  public Set<String> getDatabaseNames(){
    return Collections.EMPTY_SET;
  }
  
  /** Returns null */
  public Connection getConnection() throws DAOException {
    return null;
  }

  /** Returns null. */
  public Connection getConnection(String aDatabaseName) throws DAOException {
    return null;
  }
}
  