<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>  <%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %><%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %> <%@ taglib prefix="w" uri="/web4j" %><%@ taglib prefix="tags" tagdir="/WEB-INF/tags" %>
<w:saveToFile named='${w:asType(feature.name)}Action.java'>
package ${feature.packageName};

import hirondelle.web4j.action.ActionTemplateShowAndApply;
import hirondelle.web4j.action.ResponsePage;
import hirondelle.web4j.database.DAOException;
import hirondelle.web4j.database.SqlId;
import hirondelle.web4j.model.AppException;
import hirondelle.web4j.model.ModelCtorException;
import hirondelle.web4j.model.ModelFromRequest;
import hirondelle.web4j.request.RequestParameter;
import hirondelle.web4j.request.RequestParser;
import ${TemplatedPageClass};

/**
* View and update ${feature.name} items.
*/
public final class ${w:asType(feature.name)}Action extends ActionTemplateShowAndApply {
  
  /** Constructor. */
  public ${w:asType(feature.name)}Action(RequestParser aRequestParser){
    super(FORWARD, REDIRECT, aRequestParser);
  }

  public static final SqlId ${w:asConstant(feature.showOperation)}_${w:asConstant(feature.name)}<c:if test="${feature.showOperation == 'List'}">S</c:if> = new SqlId("${w:asConstant(feature.showOperation)}_${w:asConstant(feature.name)}<c:if test="${feature.showOperation == 'List'}">S</c:if>");
  public static final SqlId ${w:asConstant(feature.applyOperation)}_${w:asConstant(feature.name)} = new SqlId("${w:asConstant(feature.applyOperation)}_${w:asConstant(feature.name)}");
  
  <c:forEach var='field' items='${fields}'>public static final RequestParameter ${w:asConstant(field.name)} = RequestParameter.<c:if test='${field.isHardValidatedForLength}'>withLengthCheck("${w:asType(field.name)}");</c:if><c:if test='${not field.isHardValidatedForLength}'>withRegexCheck("${w:asType(field.name)}", "${field.hardValidationPattern}");</c:if>
  </c:forEach>
  /** Show the form. */
  protected void show() throws DAOException {
    ${w:asType(feature.name)}DAO dao = new ${w:asType(feature.name)}DAO();
    addToRequest(<c:if test="${feature.showOperation == 'List'}">ITEMS_FOR_LISTING</c:if><c:if test="${feature.showOperation == 'Fetch'}">ITEM_FOR_EDITING</c:if>,dao.${w:asLocal(feature.showOperation)}());
  }

  /** Check user input can build a {@link ${w:asType(feature.name)}} object. */
  protected void validateUserInput() {
    try {
      ModelFromRequest builder = new ModelFromRequest(getRequestParser());
      ${w:asField(feature.name)} = builder.build(${w:asType(feature.name)}.class, <w:noLastComma><c:forEach var='field' items='${fields}'>${w:asConstant(field.name)}, </c:forEach></w:noLastComma>);
    }
    catch (ModelCtorException ex){
      addError(ex);
    }    
  }

  /** Apply updates to the database. */
  protected void apply() throws AppException {
    ${w:asType(feature.name)}DAO dao = new ${w:asType(feature.name)}DAO();
    dao.${w:asLocal(feature.applyOperation)}(${w:asField(feature.name)});
    addMessage("${feature.name} updated successfully.");
  }
  
  // PRIVATE //
  private ${w:asType(feature.name)} ${w:asField(feature.name)};
  private static final ResponsePage FORWARD = TemplatedPage.get("${feature.name}", "view.jsp", ${w:asType(feature.name)}Action.class);
  private static final ResponsePage REDIRECT = new ResponsePage("${w:asType(feature.name)}Action.do?Operation=Show");
}
</w:saveToFile>