package hirondelle.web4jtools.codegenerator.codes;

/** Enumeration for the class of a field in a Model Object.  */
public enum FieldType {
  
  Id(hirondelle.web4j.model.Id.class.getName()), 
  SafeText(hirondelle.web4j.security.SafeText.class.getName()),
  String(null),
  Boolean(null),
  Date(java.util.Date.class.getName()),
  DateTime(hirondelle.web4j.model.DateTime.class.getName()),
  Decimal(hirondelle.web4j.model.Decimal.class.getName()),
  BigDecimal(java.math.BigDecimal.class.getName()),
  Integer(null),
  Long(null),
  Locale(java.util.Locale.class.getName()),
  TimeZone(java.util.TimeZone.class.getName());

  /** Return the package-qualified name of the class.  */
  public String getQualifiedName() { return fQualifiedName; }
  
  // PRIVATE //

  /**
  * The package-qualified name is necessary only when the class is not in java.lang.
  */
  private FieldType(String aQualifiedName){
    fQualifiedName = aQualifiedName;
  }
  
  private final String fQualifiedName;
}
