<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>  <%@ taglib uri="http://java.sun.com/jsp/jstl/fmt" prefix="fmt" %><%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %> <%@ taglib prefix="w" uri="/web4j" %><%@ taglib prefix="tags" tagdir="/WEB-INF/tags" %>
<w:saveToFile named='${w:asType(feature.name)}.java'>
package ${feature.packageName};

/*
* You MUST review this generated class :
*  - is it immutable? does it need defensive copies for Date fields?
*  - is it mutable? if so, then the hashCode implementation must not cache its value.
*  - does it use code tables?
*  - does it need to handle null values in the constructor in a special way?
*  - is the javadoc adequate?
*  - does getSignificantFields() include the desired values, in the desired order?
*/

import hirondelle.web4j.model.Check;
import hirondelle.web4j.model.ModelCtorException;
import hirondelle.web4j.model.ModelUtil;
import static hirondelle.web4j.util.Consts.FAILS;
<c:forEach var='item' items='${imports}'>import ${item};
</c:forEach>
/** Model Object for a ${w:safe(feature.name)}. */
public final class ${w:asType(feature.name)} {

  /**
  * Full constructor.
  *  
  <c:forEach var='item' items='${fields}'>* @param ${w:asArgument(item.name)} ${w:safe(item.description)}
  </c:forEach>*/
  public ${w:asType(feature.name)}(
 <w:noLastComma><c:forEach var='item' items='${fields}'>  ${item.type} ${w:asArgument(item.name)}, 
 </c:forEach></w:noLastComma>
  ) throws ModelCtorException {
  <c:forEach var='item' items='${fields}'>  ${w:asField(item.name)} = ${w:asArgument(item.name)};
  </c:forEach>  validateState();
  }
  
  <c:forEach var='item' items='${fields}'>public ${item.type} get${w:asType(item.name)}() { return ${w:asField(item.name)}; }  
  </c:forEach>
  @Override public String toString(){
    return ModelUtil.toStringFor(this);
  }
  
  @Override public boolean equals(Object aThat){
    Boolean result = ModelUtil.quickEquals(this, aThat);
    if ( result == null ) {
      ${w:asType(feature.name)} that = (${w:asType(feature.name)})aThat;
      result = ModelUtil.equalsFor(this.getSignificantFields(), that.getSignificantFields());
    }
    return result;
  }
  
  @Override public int hashCode(){
    if ( ${w:asField('HashCode')} == 0 ) {
      ${w:asField('HashCode')} = ModelUtil.hashCodeFor(getSignificantFields());
    }
    return ${w:asField('HashCode')};
  }

  // PRIVATE //
<c:forEach var='item' items='${fields}'>  private final ${item.type} ${w:asField(item.name)};
</c:forEach>  private int ${w:asField('HashCode')};

  private void validateState() throws ModelCtorException {
    ModelCtorException ex = new ModelCtorException();
    <c:forEach var='field' items='${fields}'><c:if test='${not empty field.errorMessage}'>
    if ( FAILS == Check.<c:if test='${field.isRequired}'>required</c:if><c:if test='${not field.isRequired}'>optional</c:if>(${w:asField(field.name)}<w:noLastComma>, ${w:checks(field)}</w:noLastComma>) ) {
      ex.add("${field.errorMessage}");
    }</c:if></c:forEach>

    if ( ! ex.isEmpty() ) throw ex;
  }
  
  private Object[] getSignificantFields(){
    return new Object[] {<w:noLastComma><c:forEach var='item' items='${fields}'><c:if test='${not item.isPrimaryKey}'>${w:asField(item.name)}, </c:if></c:forEach></w:noLastComma>};
  }
}
</w:saveToFile>