package hirondelle.web4jtools.codegenerator.restart;

import hirondelle.web4j.action.ActionImpl;
import hirondelle.web4j.request.RequestParser;
import hirondelle.web4j.action.ResponsePage;
import hirondelle.web4j.model.AppException;
import hirondelle.web4jtools.codegenerator.feature.FeatureAction;
import hirondelle.web4jtools.codegenerator.field.FieldAction;

/**
* Start a new feature. 
* 
* <P>Removes any existing items related to the feature from the session, 
* and then redirects to the <tt>Feature</tt> page.
*/
public final class StartFreshAction extends ActionImpl {

  public StartFreshAction(RequestParser aRequestParser){
    super(REDIRECT, aRequestParser);
  }
  
  @Override  public ResponsePage execute() throws AppException {
    removeItemsFromSession();
    return getResponsePage();
  }
  
  // PRIVATE //
  private static final ResponsePage REDIRECT = new ResponsePage("../feature/FeatureAction.do?Operation=Show");
  
  private void removeItemsFromSession() {
    removeFromSession(FeatureAction.FEATURE_KEY);
    removeFromSession(FieldAction.FIELDS_KEY);
  }
}
