<%-- Down Time. --%>
<%@ include file="/JspHeader.jsp" %>
<w:help>
<div class="help">
<w:txt wikiMarkup="true" translate="false">
Extract down time from application logs. 
Down times are calculated using _all_ the files in the application 
logging directory, not just the most recent log file. The calculation of down time 
is derived from both last-modified dates on files, and from the time of the _first_
log record in the _subsequent_ file.

For example, if there are two log files A and B in the application logging directory, 
with A coming before B, then a single down time can be calculated as 

^(time of first record of B) - (last-modified date of A)^

Clearly, this only works if the application starts a new log file upon startup
(which is almost always the case).

Since log files are often cycled regularly, such intervals will occur even when the 
application is not down. Thus, it makes sense to treat such intervals as 'real' 
down time only when they exceed some minimum duration.
</w:txt>
</div>
</w:help>


<P>
<table class="report" align="center"> 
 <tr><th colspan='4' align='center'>Down Time</th></tr>
 <tr>
   <th>Minutes</th>
   <th align='center'>From</th>
   <th align='center'>To</th>
 <c:forEach var='item' items='${downTimes}'>
 <c:if test='${item.duration > 2}'>
 <tr>
  <td align='right'>
    <c:if test='${item.duration < 60}'>
     <fmt:formatNumber value='${item.duration}' pattern='#,##0' />
    </c:if>
    <c:if test='${item.duration >= 60}'>
     <span class='log-severe'><fmt:formatNumber value='${item.duration}' pattern='#,##0' /></span>
    </c:if>
  </td>
  <td align='right'><fmt:formatDate value='${item.from}' pattern='h:mm:ss a MMM dd'/></td>
  <td align='right'><fmt:formatDate value='${item.to}' pattern='h:mm:ss a MMM dd'/></td>
  </tr>
 </c:if>
 </c:forEach>
</table>
