package hirondelle.web4jtools.logview.parser;

import hirondelle.web4jtools.logview.simpleview.LogFor;

/**
* Returns a {@link LogParser} either for an application log file, or a server log file.
* 
* <P>If you need to create an alternate version of {@link LogParser}, then you 
* should 
*<ul>
* <li>place it in this package, and make it package-private
* <li>alter the implementation of this class, to return it as required.
*</ul>
*/
public final class LogParserInstance {
  
  public static LogParser getFor(LogFor aLogFor){
    /*
    * This implementation is redundant, but allows for future changes, if needed.
    * 
    * It allows for various parser implementations, should they be 
    * required. It also allows the server logs to be in a different format from the 
    * application logs.
    */
    LogParser result = null;
    if( LogFor.Application == aLogFor ) {
      result = new LogParserForJDKDefault();
    }
    else if ( LogFor.Server == aLogFor ) {
      result = new LogParserForJDKDefault();
    }
    return result;
  }
  
  private LogParserInstance(){} //hide from caller
}
