package hirondelle.web4jtools.logview.stats;

import java.util.logging.Level;

/**
* Model Object for a histogram element attached to a logging level.
* 
* <P>This class is mutable.
*/
public final class LevelBucket {

  /** Full constructor.  */
  public LevelBucket(Level aLevel){
    fLevel = aLevel;
    validateState();
  }
  
  /** Increase the number of items in this bucket by one. */
  public void incrementCount(){ ++fCount; }
  
  /** Return the number of items in this bucket.  */
  public Integer getCount(){ return fCount; }
  
  public Level getLevel(){  return fLevel; }  
  
  // PRIVATE //
  private Level fLevel;
  private int fCount;
  
  private void validateState() {
    if ( fLevel == null ) {
      throw new IllegalArgumentException("Level is required.");
    }
  }
}
