<%-- Image References --%>
<%@ include file="/JspHeader.jsp" %>

<w:help>
<div class="help">
<w:txt wikiMarkup="true" translate="false">
  Lists references to images. 
  If an image has no references, then it is a candidate for deletion.
  
  Thumbnails can only be displayed if the setting in web.xml is not 
  blank, and points to a specific URI on a currently running web app, 
  that will serve the desired image files. (Occasionally, you may need to 
  temporarily disable security constraints in web.xml in order for this to work.
  If a security-constraint protects the images, then this tool will not get 
  past the login page.)
  
  Before removing unreferenced images, it is recommended that you confirm they 
  aren't being used with another tool. (An image may be used in a non-markup file, 
  for example.)
</w:txt>
</div>
</w:help>

<P>
<table class="report" align="center"> 
 <tr>
   <th title='Simple file name'>Name<tags:sortLinks column="Name" baseURI=""/></th>
   <th title='Thumbnail version of the image'>Thumb</th>
   <th title='Number of references to the image in designated markup files'>#Refs<tags:sortLinks column="NumReferences" baseURI=""/></th>
   <th title='Size of the image file'>Bytes<tags:sortLinks column="Bytes" baseURI=""/></th>
   <th title='Full name of markup files that reference the image'>Referencing Files</th>
   <th title='The undistorted image'>Full</th>
 </tr>
 <c:forEach var='item' items='${imgReferences}'>
 <tr>
  <td title='Simple file name'>${item.fileInfo.simpleName}</td>
  <td title='Thumbnail version of the image' align='left'>
    <c:if test='${not empty baseInfo.baseURIForFetchingImages}'><img src='${baseInfo.baseURIForFetchingImages}${item.fileInfo.simpleName}' width='30' height='30'></c:if>
  </td>
  <td title='Number of references to the image in designated markup files' align='right'><fmt:formatNumber value='${item.numReferences}' pattern='#,##0'/></td>
  <td title='Size of the image file' align='right'><fmt:formatNumber value='${item.fileInfo.size}' pattern='#,##0'/></td>
  <td title='Full name of markup files that reference the image' align='left' style='font-size: 70%'>
   <c:if test='${empty item.referencingFiles}'><b>Not referenced</b> in any file with extension : ${markupFileExtensions}</c:if>
   <c:if test='${not empty item.referencingFiles}'>
    <c:forEach var='ref' items='${item.referencingFiles}'><c:url var='fileURI' value='${w:fileURL(ref.name.rawString)}'/><a href='${fileURI}' title='Paste URI directly into address bar. Browser may not follow file:// URIs.'>${ref.name}</a><br></c:forEach>
   </c:if>
  </td>
  <td title='The undistorted image' align='left'>
    <c:if test='${not empty baseInfo.baseURIForFetchingImages}'><img src='${baseInfo.baseURIForFetchingImages}${item.fileInfo.simpleName}'></c:if>
  </td>
  </tr>
 </c:forEach>
</table>
